#ifdef __cplusplus

  extern "C" {
  
#endif

#define NUMBEROFCHANNELS 32
 
extern struct scpi_parser_context ctx;
extern uint8_t iPins[NUMBEROFCHANNELS];
extern uint8_t bDigital[(NUMBEROFCHANNELS+7)/8];  // rounding up to next full byte

void scpi_user_init(void);

scpi_error_t    identify(struct scpi_parser_context* context, const char* token[]);
scpi_error_t       reset(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital(struct scpi_parser_context* context, const char* token[], int channel);
scpi_error_t set_digital(struct scpi_parser_context* context, const char* token[], int channel);

scpi_error_t get_digital_1(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_2(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_3(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_4(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_5(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_6(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_7(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_8(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_9(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_10(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_11(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_12(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_13(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_14(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_15(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_16(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_17(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_18(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_19(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_20(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_21(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_22(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_23(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_24(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_25(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_26(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_27(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_28(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_29(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_30(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_31(struct scpi_parser_context* context, const char* token[]);
scpi_error_t get_digital_32(struct scpi_parser_context* context, const char* token[]);

scpi_error_t set_digital_1(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_2(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_3(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_4(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_5(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_6(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_7(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_8(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_9(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_10(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_11(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_12(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_13(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_14(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_15(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_16(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_17(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_18(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_19(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_20(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_21(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_22(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_23(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_24(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_25(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_26(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_27(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_28(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_29(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_30(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_31(struct scpi_parser_context* context, const char* token[]);
scpi_error_t set_digital_32(struct scpi_parser_context* context, const char* token[]);

#ifdef __cplusplus
  }
#endif
