#include "scpiparser.h"
#include "scpi_user.h"
#include <Arduino.h>
#include "scpi_user.h"
#include "test.h"

char line_buffer[100];
int read_length;

void setup() {
  int i;

  Serial.begin(9600);
  for (i = 0; i < NUMBEROFCHANNELS; i++) {
    pinMode(iPins[i], OUTPUT);
    digitalWrite(iPins[i], LOW);
  }
  scpi_init(&ctx);
  scpi_user_init();
  identify(&ctx, (const char**)token_list);
  dump_cmd_tree(ctx.command_tree, 0);        // DEBUG
}

void loop() {
  /* Read in a line and execute it. */
  read_length = Serial.readBytesUntil('\n', line_buffer, sizeof(line_buffer)-1);  
  if(read_length > 0) {
    line_buffer[read_length]=0;
  	scpi_execute_command(&ctx, line_buffer);
	}
}
